#Initialising Values
    execute unless score init lobby matches 1 run function winged:initialize_values

#General
    function winged:lobby/doors
    #execute as @a[tag=ingame] at @s run function winged:music/main
    execute as @a[scores={leave_game=1..}] at @s run function winged:relog
    execute as @a[tag=!setup] at @s run scoreboard players set @s stats.wins 0
    execute as @a[tag=!setup] at @s run scoreboard players set @s stats.defeats 0
    execute as @a[tag=!setup] at @s run scoreboard players set @s stats.kills 0
    execute as @a[tag=!setup] at @s run scoreboard players set @s stats.deaths 0
    execute as @a[tag=!setup] at @s run function winged:relog
    execute as @a[tag=in_lobby] at @s run function winged:lobby/lobby_main
    execute if entity @a[tag=in_queue] run function winged:queue/queue_main
    execute unless entity @a[tag=in_queue] unless score queue.t queue matches 1200 run scoreboard players set queue.t queue 1200

    #Sounds
        execute as @a[tag=ingame] at @s run function winged:sounds/main
    #Eye of Ender in Offhand
        item replace entity @a[predicate=!winged:if_in_aircraft] weapon.offhand with minecraft:ender_eye{display:{Name:'{"text":""}'}}
        execute if score .limeTowerS islands matches ..1 run item replace entity @a[predicate=winged:if_in_aircraft,tag=team.lime] weapon.offhand with minecraft:filled_map{map:0}
        execute if score .yellowTowerS islands matches ..1 run item replace entity @a[predicate=winged:if_in_aircraft,tag=team.yellow] weapon.offhand with minecraft:filled_map{map:0}
        execute if score .limeTowerS islands matches 2 run item replace entity @a[predicate=winged:if_in_aircraft,tag=team.lime] weapon.offhand with air
        execute if score .yellowTowerS islands matches 2 run item replace entity @a[predicate=winged:if_in_aircraft,tag=team.yellow] weapon.offhand with air
        execute as @a store result score @s eyeCount run clear @s ender_eye 0
        clear @a[scores={eyeCount=2..},predicate=!winged:if_in_aircraft,tag=!in_lobby] ender_eye

    #Vis Fix
        execute as @e[type=snowball] run function winged:aircrafts/bullets/vis_fix
        scoreboard players operation .global visfix *= .-1 visfix
        execute as @a[gamemode=adventure] at @s if block ~ ~ ~ water run tag @s add player_died_in_water
        execute as @a[gamemode=adventure] at @s if block ~ ~ ~ seagrass run tag @s add player_died_in_water
        execute as @p[tag=player_died_in_water] at @s run tellraw @a [{"text":"["},{"text":"☠","color":"#61D5FF"},{"text":"]"},{"text":" "},{"selector":"@s"},{"text":" took a bath.","color":"#FFFFFF"}]
        execute as @a[tag=player_died_in_water] run function winged:game/respawn
        tag @a remove player_died_in_water
        execute as @a[gamemode=!spectator] at @s if block ~ ~ ~ #minecraft:leaves run tp @s ~ ~1 ~

#Buildings (Target Marker)
    execute as @e[type=marker,tag=building] at @s run function winged:buildings/main

#Coloured Trails
    execute as @e[tag=team.lime,type=armor_stand] at @s run particle dust 0 1 0.1 1 ^ ^-0.3 ^-1 0.1 0.1 0.1 0 12
    execute as @e[tag=team.yellow,type=armor_stand] at @s run particle dust 1 1 0 1 ^ ^-0.3 ^-1 0.1 0.1 0.1 0 12
    execute as @e[tag=aircraft,scores={aircraft_health=..1000}] at @s run particle smoke ^ ^ ^1.5 0.2 0.2 0.2 0 10

#Spectator
    #Back Trigger
        scoreboard players enable @a[gamemode=spectator] back
        execute as @a[gamemode=!spectator,scores={back=1..}] run tellraw @s [{"text":"[","color":"white"},{"text":"!","bold":true,"color":"gold"},{"text":"]","color":"white"},{"text":" You cannot trigger this objective yet.","color":"red"}]
        execute as @a[gamemode=spectator,scores={back=1..}] run tellraw @a [{"text":"[","color":"white"},{"text":"!","bold":true,"color":"gold"},{"text":"] ","color":"white"},{"selector":"@s","color":"dark_green"},{"text":" is no longer spectating.","color":"gray"}]
        tag @a[gamemode=!spectator] remove spectating
        execute as @a[gamemode=spectator,scores={back=1..}] run function winged:relog
        scoreboard players set @a[scores={back=1..}] back 0

    #TP Up if lower than y=87
        execute as @a[gamemode=spectator] store result score @s ylvl run data get entity @s Pos[1]
        execute as @a[gamemode=spectator,scores={ylvl=..86}] at @s run tp @s ~ ~5 ~

#Game Master
    execute unless entity @a[tag=game_master] as @a[limit=1,sort=random] run function winged:game_master/become

#Aircrafts
    execute as @e[type=armor_stand,tag=plane] at @s run function winged:aircrafts/mechanics/planes/fly
    execute as @e[type=armor_stand,tag=helicopter] at @s run function winged:aircrafts/mechanics/helicopters/fly
    execute as @e[type=armor_stand,tag=aircraft] at @s run function winged:aircrafts/main

    #Inside Aircraft
        execute as @a[predicate=winged:if_in_aircraft] at @s run function winged:aircrafts/in_aircraft

#Menu
    execute if score .slide lobby matches 1.. run function winged:lobby/menu/main


#Projectiles
    #Snowball
        execute as @e[tag=bullet_land] unless predicate winged:is_riding_snowball at @s run function winged:aircrafts/bullets/landed/landed
        execute as @e[tag=projectile_land] unless predicate winged:is_riding_snowball at @s run function winged:aircrafts/projectiles/landed/landed

    #Bullets
        execute as @e[tag=bullet,type=snowball] at @s run function winged:aircrafts/bullets/bullets


#Ingame
    #Main
        execute if entity @a[tag=ingame] run function winged:game/bossbar
        execute if entity @a[tag=in_queue] unless entity @a[tag=ingame] run function winged:in_queue/queue_main

    #Drills
        execute if score .drills settings matches 1 positioned 0 111 138 as @a[dx=32,dz=32,dy=50,gamemode=adventure] run tag @s add drill0
        execute if score .drills settings matches 1 positioned 0 111 138 if entity @a[dx=32,dz=32,dy=50,gamemode=adventure] run function winged:game/islands/drills/capture
        execute if score .drills settings matches 1 positioned -36 111 -165 as @a[dx=32,dz=32,dy=50,gamemode=adventure] run tag @s add drill1
        execute if score .drills settings matches 1 positioned -36 111 -165 if entity @a[dx=32,dz=32,dy=50,gamemode=adventure] run function winged:game/islands/drills/capture
        execute if score .drills settings matches 1 if entity @a[tag=drill0] run tag @a[tag=drill0] remove drill0
        execute if score .drills settings matches 1 if entity @a[tag=drill1] run tag @a[tag=drill1] remove drill1
    
    #Shooting
        execute as @a[scores={drop=1..}] at @s run function winged:drop

    #Eggnade
        execute as @e[type=chicken,tag=eggnade] at @s run function winged:aircrafts/abilities/chicken


#Shop
    execute as @e[tag=shopPos] at @s run function winged:shop/main
    execute positioned -169 108 -12 if entity @a[distance=..20] unless entity @e[tag=shopPos,distance=..2] run summon armor_stand ~ ~ ~ {Tags:["shopPos","shopYellow"],Invisible:1b,Marker:1b,NoGravity:1b,ArmorItems:[{},{},{},{id:"minecraft:stone",Count:100b}]}
    execute positioned 164 108 19 if entity @a[distance=..20] unless entity @e[tag=shopPos,distance=..2] run summon armor_stand ~ ~ ~ {Tags:["shopPos","shopLime"],Invisible:1b,Marker:1b,NoGravity:1b,ArmorItems:[{},{},{},{id:"minecraft:stone",Count:100b}]}
    execute as @e[type=armor_stand,tag=shopLime,tag=!shopstp] at @s run tp @s ~ ~ ~ ~180 ~
    tag @e[type=armor_stand,tag=shopLime,tag=!shopstp] add shopstp

#Tutorial
    execute if score tutorial.running lobby matches 0.. run function winged:lobby/tutorial

#Rests
    scoreboard players set @a[tag=!right_click_prep] right_click_prep 0
    scoreboard players set @a[scores={right_click_prep=0}] right_click 0
    tag @a remove right_click_prep
    execute if predicate wasd:is_mounted run function wasd:mounted
    kill @e[type=item]
    execute unless entity @e[type=armor_stand,tag=homing_carrot] run tag @e remove missile_locked
#Airmines
    execute if entity @p[tag=ingame] if score .airmines settings matches 1 run function winged:game/air_mine/spawn
    execute as @e[type=armor_stand,tag=air_mine] at @s run function winged:game/air_mine/main
#Respawn
    execute as @a[scores={death=1..}] run function winged:game/respawn
    execute as @a if score @s respawn matches 1.. run function winged:game/respawn
#Music loop
    execute if entity @p[tag=ingame] if score .main music.loop matches 3001.. run scoreboard players set .main music.loop 0
    execute as @a[tag=ingame] at @s if score .main music.loop matches 0 run playsound winged:music.main record @s ~ ~ ~ 1 1
    execute if entity @p[tag=ingame] run scoreboard players add .main music.loop 1
#Game end tickdown
    execute as @a[tag=ingame] at @s if score .ingame.t islands matches ..600 run function winged:game/ending_timer

effect give @a resistance 1 255 true
effect give @a saturation 99999 255 true
effect give @a[tag=!ingame] weakness 1 255 true


scoreboard players add timer Data 1
execute if score timer Data matches 10.. run scoreboard players set timer Data 0
execute as @a[scores={spawn_protection=1..},gamemode=!spectator,predicate=!winged:if_in_aircraft] at @s run function winged:game/halo/animate
scoreboard players remove @a[scores={spawn_protection=1..}] spawn_protection 1

execute as @e[type=armor_stand,scores={ring_boost=1..}] at @s run function winged:game/ring_boost/aircraft
execute as @e[type=marker,tag=ring_boost,scores={ring_boost=1..}] at @s run function winged:game/ring_boost/cooldown